-----------------------
-- OCD               --
-- By: Wire @ Byriel --
-----------------------

CooldownManager = class();

CooldownManager.Constants = {
  Abilities = {
    Global = {
      
      -- test
      --GlobalAbility("Lifegiving Veil", {20, 15, 10}, true, "What is up my soulwalkers!"),
      
      -- soul walk
      GlobalAbility(OCD:T("A.G.SoulWalk"), {60 * 60, 55 * 60, 50 * 60}, true, "What is up my soulwalkers!")
    },
    Local = {
      
      -- test
      --LocalAbility("Bloom", {25, 15}, true, LocalAbility.Constants.Genre.Test, LocalAbility.Constants.Calling.Mage),
      --LocalAbility("Natural Awareness", {10}, true, LocalAbility.Constants.Genre.Test, LocalAbility.Constants.Calling.Mage),
      
      -- combat rez
      LocalAbility(OCD:T("A.L.Absolution"), {5 * 60}, true, LocalAbility.Constants.Genre.CombatRez, LocalAbility.Constants.Calling.Cleric), -- 31 Justicar
      LocalAbility(OCD:T("A.L.LifesReturn"), {5 * 60}, true, LocalAbility.Constants.Genre.CombatRez, LocalAbility.Constants.Calling.Cleric), -- 32 Sentinel
      LocalAbility(OCD:T("A.L.RiseofthePhoenix"), {5 * 60}, true, LocalAbility.Constants.Genre.CombatRez, LocalAbility.Constants.Calling.Cleric), -- 44 Purifier
      LocalAbility(OCD:T("A.L.RiverofLife"), {5 * 60}, true, LocalAbility.Constants.Genre.CombatRez, LocalAbility.Constants.Calling.Cleric), -- 44 Warden
	  LocalAbility(OCD:T("A.L.SoulTether"), {5 * 60, 4.5 * 60, 4 * 60}, true, LocalAbility.Constants.Genre.CombatRez, LocalAbility.Constants.Calling.Mage), -- 20 Chloromancer
      LocalAbility(OCD:T("A.L.SparkofLife"), {10 * 60}, true, LocalAbility.Constants.Genre.CombatRez, LocalAbility.Constants.Calling.Mage), -- 44 Stormcaller
      
      -- rotation
      LocalAbility(OCD:T("A.L.ReflectiveCommand"), {20}, false, LocalAbility.Constants.Genre.Rotation, LocalAbility.Constants.Calling.Mage), -- 6 Dominator
      LocalAbility(OCD:T("A.L.NaturalConversion"), {90, 60, 30}, false, LocalAbility.Constants.Genre.Rotation, LocalAbility.Constants.Calling.Mage), -- 12 Chloromancer
      LocalAbility(OCD:T("A.L.WildGrowth"), {58.5}, false, LocalAbility.Constants.Genre.Rotation, LocalAbility.Constants.Calling.Mage), -- 26 Chloromancer
      LocalAbility(OCD:T("A.L.SpiritualConflagration"), {60}, false, LocalAbility.Constants.Genre.Rotation, LocalAbility.Constants.Calling.Cleric), -- 51 Purifier      
      LocalAbility(OCD:T("A.L.HealersCovenant"), {2 * 60}, false, LocalAbility.Constants.Genre.Rotation, LocalAbility.Constants.Calling.Cleric),
      LocalAbility(OCD:T("A.L.FusionofFlesh"), {3 * 60, 2.5 * 60}, false, LocalAbility.Constants.Genre.Rotation, LocalAbility.Constants.Calling.Warrior),
      LocalAbility(OCD:T("A.L.Singularity"), {60}, false, LocalAbility.Constants.Genre.Rotation, LocalAbility.Constants.Calling.Warrior),
      
      -- buffs
      LocalAbility(OCD:T("A.L.VerseofJoy"), {120, 96}, true, LocalAbility.Constants.Genre.Buff, LocalAbility.Constants.Calling.Rogue), -- 51 Bard
      LocalAbility(OCD:T("A.L.FlaringPower"), {5 * 60, 2 * 60}, true, LocalAbility.Constants.Genre.Buff, LocalAbility.Constants.Calling.Mage), -- 32 Archon
      LocalAbility(OCD:T("A.L.AssaultCommand"), {5 * 60, 2 * 60}, false, LocalAbility.Constants.Genre.Buff, LocalAbility.Constants.Calling.Warrior), -- 32 Warlord
      LocalAbility(OCD:T("A.L.AidCommand"), {5 * 60, 2 * 60}, false, LocalAbility.Constants.Genre.Buff, LocalAbility.Constants.Calling.Warrior), -- 26 Warlord
      LocalAbility(OCD:T("A.L.RallyingCommand"), {5 * 60, 2 * 60}, false, LocalAbility.Constants.Genre.Buff, LocalAbility.Constants.Calling.Warrior), -- 31 Warlord
      
      -- defensive
      LocalAbility(OCD:T("A.L.TouchofLife"), {10 * 60}, false, LocalAbility.Constants.Genre.Defensive, LocalAbility.Constants.Calling.Warrior), -- 8 Paladin
      
      -- offensive
      LocalAbility(OCD:T("A.L.Intercept"), {30}, false, LocalAbility.Constants.Genre.Offensive, LocalAbility.Constants.Calling.Warrior), -- 16 Warlord
      LocalAbility(OCD:T("A.L.Incriminate"), {30}, false, LocalAbility.Constants.Genre.Offensive, LocalAbility.Constants.Calling.Rogue),
      LocalAbility(OCD:T("A.L.HeatWave"), {120, 105}, false, LocalAbility.Constants.Genre.Offensive, LocalAbility.Constants.Calling.Mage), -- 31 Pyro
    }
  }
};

CooldownManager.Defaults = {
  TimerSpacing = 2,
  Stacking = false
};

function CooldownManager:Constructor(application)
  
  -- parameters
  self:SetApplication(application);
  self:SetParent(self:GetApplication():GetContext());
  self:SetIdle(self:GetApplication():GetIdle());
  
  -- cooldown bar
  self:SetCooldownBar(Wired.UI.CascadeBar(self:GetApplication():GetName() .. "_CooldownBar", self:GetApplication():GetContext(), {Left = (UIParent:GetWidth() - 300), Top = (UIParent:GetHeight() * 0.75)}));
  self:GetCooldownBar():SetTitle("Wire's " .. self:GetApplication():GetName() .. " Cooldowns");
  
  -- local abilities
  self.localAbilities = Wired.Persistence.PersistentVariable(
    "LocalAbilities", self:GetParent():GetBase(), nil
  );
  
  -- defaults
  self:ApplyCooldownManagerDefaults();
  
  -- create abilities
  self:CreateAbilities();
  
  -- stacking
  self.stacking = Wired.Persistence.PersistentVariable(
    "Stacking",
     self:GetParent():GetBase(),
     CooldownManager.Defaults.Stacking
  );
  
  -- idle
  self:GetIdle().Wired.Event.Listener:Add(Wired.Event.Listener(
    "Idle",
    function()
      self:Idle();
    end,
    true
  ));
  
  -- buff added
  table.insert(Event.Buff.Add, {
    function(unit, buffs)
      self:BuffAdded(unit, buffs);
    end,
    self:GetApplication():GetName(),
    "Buff Added Handler"
  });
  
  -- healed
  table.insert(Event.Combat.Heal, {
    function(value)
      self:Healed(value);
    end,
    self:GetApplication():GetName(),
    "Healed Handler"
  });
  
  --[[
  -- units changed
  table.insert(Event.Unit.Available, {
    function(value)
      self:UnitsChanged(value);
    end,
    self:GetApplication():GetName(),
    "Units Changed Handler"
  });
  --]]
end

-- application
function CooldownManager:GetApplication()
  return self.application;
end

function CooldownManager:SetApplication(value)
  self.application = value;
end

-- parent
function CooldownManager:GetParent()
  return self.parent;
end

function CooldownManager:SetParent(value)
  self.parent = value;
end

-- idle
function CooldownManager:GetIdle()
  return self.idle;
end

function CooldownManager:SetIdle(value)
  self.idle = value;
end

-- cooldown bar
function CooldownManager:GetCooldownBar()
  return self.cooldownBar;
end

function CooldownManager:SetCooldownBar(value)
  self.cooldownBar = value;
  
  -- register bar
  self:GetApplication():RegisterCascadeBar(value);
end

-- stacking
function CooldownManager:GetStacking()
  return self.stacking:GetValue();
end

function CooldownManager:SetStacking(value)
  self.stacking:SetValue(value);
  
  -- redraw timers
  self:RedrawTimers();
end

-- options
function CooldownManager:GetOptions()
  if (not self.options) then
    self.options = self:GetApplication():GetOptions();
  end
  return self.options;
end

-- raid
function CooldownManager:GetRaid()
  if (not self.raid) then
    self.raid = self:GetOptions():GetRaid();
  end
  return self.raid;
end

-- abilities
function CooldownManager:GetAbilities()
  if (type(self.abilities) ~= "table") then
    self.abilities = {};
  end
  return self.abilities;
end

function CooldownManager:SetAbilities(value)
  self.abilities = value;
end

-- timers by ability
function CooldownManager:GetTimersByAbility()
  if (type(self.timersByAbility) ~= "table") then
    self.timersByAbility = {};
  end
  return self.timersByAbility;
end

-- timers by player
function CooldownManager:GetTimersByPlayer()
  if (type(self.timersByPlayer) ~= "table") then
    self.timersByPlayer = {};
  end
  return self.timersByPlayer;
end

-- add timer
function CooldownManager:AddTimer(timer, ability, player)
  
  -- index by ability
  if (type(self:GetTimersByAbility()[ability:GetName()]) ~= "table") then
    self:GetTimersByAbility()[ability:GetName()] = {};
  end
  self:GetTimersByAbility()[ability:GetName()][player:GetName()] = timer;
  
  -- index by player
  if (type(self:GetTimersByPlayer()[player:GetName()]) ~= "table") then
    self:GetTimersByPlayer()[player:GetName()] = {};
  end
  self:GetTimersByPlayer()[player:GetName()][ability:GetName()] = timer;
end

-- get timer
function CooldownManager:GetTimer(ability, player)
  local result = nil;
  if (self:GetTimersByAbility()[ability:GetName()]) then
    result = self:GetTimersByAbility()[ability:GetName()][player:GetName()];
  end
  return result;
end

-- genre bars
function CooldownManager:GetGenreBars()
  if (type(self.genreBars) ~= "table") then
    self.genreBars = {};
  end
  return self.genreBars;
end

-- local abilities
function CooldownManager:GetLocalAbilities()
  if (type(self.localAbilities:GetValue()) ~= "table") then
    self.localAbilities:SetValue({});
  end
  return self.localAbilities:GetValue();
end

-- defaults
function CooldownManager:ApplyCooldownManagerDefaults()
  
end

-- create abilities
function CooldownManager:CreateAbilities()
  local abilities = {};
  for j, group in pairs(CooldownManager.Constants.Abilities) do
    for k, ability in pairs(group) do
      abilities[ability:GetName()] = ability;
      
      -- register
      ability:SetManager(self);
      
      -- enabled
      if (ability:GetData().Enabled ~= nil) then
        ability:SetEnabled(ability:GetData().Enabled);
      end
    end
  end
  self:SetAbilities(abilities);
end

-- idle
function CooldownManager:Idle()

end

-- start countdown
function CooldownManager:StartCountdown(ability, player)
  if (not player:GetAbilities()[ability:GetName()]) then
    player:GetAbilities()[ability:GetName()] = {};
  end
  player:GetAbilities()[ability:GetName()].time = Inspect.Time.Frame();
end

-- start timer
function CooldownManager:StartTimer(ability, player)
    
  -- create timer
  local timer = self:GetTimer(ability, player);
  if (not timer) then
    timer = (Wired.UI.Timer(
      "Timer_" .. ability:GetName() .. "_" .. player:GetName(),
      self:GetParent(),
      self:GetApplication()
    ));
    
    -- visible
    timer:GetBase().Wired.Event.Listener:Add(Wired.Event.Listener(
      "StationaryClick",
      function()
        
        -- deactivate timer
        if (timer:GetActive()) then
          
          -- push timer to end and stop
          timer:SetValue(0);
          timer:SetActive(false);
          
          -- redraw
          self:RedrawTimers();
          
        -- activate timer
        else
          self:StartTimer(ability, player);
        end
      end,
      true
    ));
    
    -- finished
    timer.Wired.Event.Listener:Add(Wired.Event.Listener(
      "TimerFinished",
      function()
        self:RedrawTimers();
      end,
      true
    ));
    
    -- reset timer
    timer:SetPercentage(false);
    timer:SetFlipped(true);
    timer:SetTransient(false);
    
    -- cooldown
    local raid = self:GetApplication():GetOptions():GetRaid();
    local cooldown = ability:GetCooldown()[1];
    if (player) then
      if (player:GetAbilities()[ability:GetName()]) then
        if (player:GetAbilities()[ability:GetName()].duration) then
          cooldown = player:GetAbilities()[ability:GetName()].duration;
        end
      end
    end
    
    -- scale
    timer:SetScale(Wired.Math.Scale({minimum = 0, maximum = cooldown}));
    
    -- value
    timer:SetValue(cooldown);
    
    -- title
    timer:SetTitle(player:GetName() .. ": " .. ability:GetName());
    
    -- add timer
    self:AddTimer(timer, ability, player);
  end
  
  -- activate timer
  if (not timer:GetActive()) then
    
    -- cooldown
    local cooldown = ability:GetCooldown()[1];
    if (player) then
      if (player:GetAbilities()[ability:GetName()]) then
        if (player:GetAbilities()[ability:GetName()].duration) then
          cooldown = player:GetAbilities()[ability:GetName()].duration;
        end
      end
    end
    
    -- scale
    timer:SetScale(Wired.Math.Scale({minimum = 0, maximum = cooldown}));
    
    -- value
    timer:SetValue(cooldown);
    
    -- title
    timer:SetTitle(player:GetName() .. ": " .. ability:GetName());
    
    -- reset timer
    timer:SetVisible(true);
    timer:SetActive(true);
    
    -- redraw timers
    self:RedrawTimers();
  end
end

-- buff added
function CooldownManager:BuffAdded(unit, buffs)
  
  -- enabled
  if (self:GetApplication():GetEnabled()) then
    
    -- buff details
    local buffDetails = Inspect.Buff.Detail(unit, buffs);
    if (buffDetails) then
      
      -- buffs
      for id, buff in pairs(buffDetails) do
        
        -- tracked
        local ability = nil;
        if (buff.name) then
          ability = self:GetAbilities()[buff.name];
        end
        
        -- ability
        if (ability) then
          
          -- enabled
          if (ability:GetEnabled()) then
            
            -- details
            local details = nil;
            if (buff.caster) then
              details = Inspect.Unit.Detail(buff.caster);
            end
            
            -- player
            local player = nil;
            if (details) then
              player = self:GetRaid():GetPlayersByName()[details.name];
            end
            
            -- activate
            if (player) then
              
              -- timer
              if (ability:GetScope() == Ability.Constants.Scope.Local) then
                self:StartTimer(ability, player);
                
              -- countdown
              else
                self:StartCountdown(ability, player);
              end
            end
          end
        end
      end
    end
  end
end

-- healed
function CooldownManager:Healed(value)
  
  -- enabled
  if (self:GetApplication():GetEnabled()) then
    
    -- tracked
    local ability = nil;
    if (value) then
      if (value.abilityName) then
        ability = self:GetAbilities()[value.abilityName];
      end
    end
    
    -- ability
    if (ability) then
      
      -- enabled
      if (ability:GetEnabled()) then
      
        -- details
        local details = nil;
        if (value.caster) then
          details = Inspect.Unit.Detail(value.caster)
        end
        
        -- player
        local player = nil;
        if (details) then
          player = self:GetRaid():GetPlayersByName()[details.name];
        end
        
        -- activate
        if (player) then
          
          -- timer
          if (ability:GetScope() == Ability.Constants.Scope.Local) then
            self:StartTimer(ability, player);
            
          -- countdown
          else
            self:StartCountdown(ability, player);
          end
        end
      end
    end
  end
end

-- redraw timers
function CooldownManager:RedrawTimers()
  
  -- top
  local top = self:GetCooldownBar();
  
  -- genres
  for genreName, genre in pairs(LocalAbility.Constants.Genre) do
    
    -- get sortable abilities
    local sorted = {};
    for abilityName, players in pairs(self:GetTimersByAbility()) do
      
      -- ability
      local ability = self:GetAbilities()[abilityName];
      
      -- match scope
      if (ability:GetScope() == Ability.Constants.Scope.Local) then
        
        -- match genre
        if (ability:GetGenre() == genre) then
          
          -- add timers
          for playerName, timer in pairs(players) do
            
            -- only sort active unlocked
            if (timer:GetVisible() and (not timer:GetLocked())) then
              table.insert(sorted, timer);
            end
          end
        end
      end
    end
    
    -- sort by value then scale
    table.sort(
      sorted,
      function(a, b)
        local result = a:GetValue() < b:GetValue();
        if (a:GetValue() == b:GetValue()) then
          result = a:GetScale():GetMaximum() < b:GetScale():GetMaximum();
          if (a:GetScale():GetMaximum() == b:GetScale():GetMaximum()) then
            result = a:GetTitle() < b:GetTitle();
          end
        end
        return result;
      end
    );
    
    -- show timers
    local genreBar = self:GetGenreBars()[genreName];
    if (table.getn(sorted) > 0) then
      
      -- genre bar
      if (not genreBar) then
        
        -- create bar
        genreBar = Wired.UI.CascadeBar(
          self:GetApplication():GetName() .. "_GenreBar_" .. genreName,
          self:GetApplication():GetContext()
        );
        
        -- register bar
        self:GetApplication():RegisterCascadeBar(genreBar);
        
        -- add bar
        self:GetGenreBars()[genreName] = genreBar;
        
        -- text
        genreBar:SetTitle(genreName);
      end
      
      -- move genre bar
      if (not genreBar:GetLocked()) then
        
        -- resize
        if (genreBar:GetSize() ~= self:GetCooldownBar():GetSize()) then
          genreBar:SetSize(self:GetCooldownBar():GetSize());
        end
        
        -- move
        if (self:GetStacking()) then
          genreBar:SetPosition(
            self:GetCooldownBar():GetLeft(),
            top:GetTop() - genreBar:GetHeight() - CooldownManager.Defaults.TimerSpacing
          );
        else
          genreBar:SetPosition(
            self:GetCooldownBar():GetLeft(),
            top:GetBottom() + CooldownManager.Defaults.TimerSpacing
          );
        end
      end
      
      -- show genre bar
      --genreBar:SetVisible(true);
      
      -- next
      local oldTop = top;
      top = genreBar;
      
      -- timers
      for k, timer in pairs(sorted) do
        
        -- resize
        if (timer:GetFontSize() ~= genreBar:GetSize()) then
          timer:SetFontSize(genreBar:GetSize());
        end
        
        -- move
        if (self:GetStacking()) then
          timer:SetPosition(
            genreBar:GetLeft(),
            top:GetTop() - timer:GetHeight() - CooldownManager.Defaults.TimerSpacing
          );
        else
          timer:SetPosition(
            genreBar:GetLeft(),
            top:GetBottom() + CooldownManager.Defaults.TimerSpacing
          );
        end
        
        -- next
        top = timer;
      end
      
      -- continue cascading from last if locked
      if (genreBar:GetLocked()) then
        top = oldTop;
      end
      
    -- hide genre bar
    else
      if (genreBar) then
        --genreBar:SetVisible(false);
      end
    end
  end
end

-- enabled changed
function CooldownManager:EnabledChanged(ability)
  ability:GetData().Enabled = ability:GetEnabled();
end

--[[
-- units changed
function CooldownManager:UnitsChanged(value)
  for id, specifier in pairs(value) do
    print(specifier);
  end
end
--]]
