-----------------------
-- OCD               --
-- By: Wire @ Byriel --
-----------------------

Player = class();

Player.Constants = {
  Calling = {
    Cleric = "cleric",
    Mage = "mage",
    Rogue = "rogue",
    Warrior = "warrior"
  },
  Role = {
    Tank = "tank",
    Heal = "heal",
    DPS = "dps",
    Support = "support"
  }
};

function Player:Constructor(details)
  
  -- parameters
  self:SetDetails(details);
end

-- details
function Player:GetDetails()
  return self.details;
end

function Player:SetDetails(value)
  self.details = value;
end

-- raid
function Player:GetRaid()
  return self.raid;
end

function Player:SetRaid(value)
  self.raid = value;
end

-- slot
function Player:GetSlot()
  return self.slot;
end

function Player:SetSlot(value)
  self.slot = value;
end

-- abilities
function Player:GetAbilities()
  if (type(self.abilities) ~= "table") then
    self.abilities = {};
  end
  return self.abilities;
end

function Player:SetAbilities(value)
  self.abilities = value;
end

-- name
function Player:GetName()
  return self:GetDetails().name;
end

-- calling
function Player:GetCalling()
  return self:GetDetails().calling;
end

-- planar charges
function Player:GetPlanarCharges()
  return self:GetDetails().planar;
end

-- planar charges max
function Player:GetPlanarChargesMax()
  return self:GetDetails().planarMax;
end

-- role
function Player:GetRole()
  return self:GetDetails().role;
end

-- vitality
function Player:GetVitality()
  return self:GetDetails().vitality;
end
